'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = help;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function help() {

  console.log('\n  ' + _chalk2.default.bold('pkg') + ' [options] <input>\n\n  ' + _chalk2.default.dim('Options:') + '\n\n    -h, --help       output usage information\n    -t, --targets    comma-separated list of targets (see examples)\n    -d, --debug      debug mode [off]\n    -c, --config     package.json or any json file with top-level config\n    -o, --output     output file name or template for several files\n    --out-dir        path to save output one or more executables\n    -b, --build      don\'t download prebuilt base binaries, build them\n\n  ' + _chalk2.default.dim('Examples:') + '\n\n  ' + _chalk2.default.gray('–') + ' Makes executables for Linux, macOS and Windows\n\n    ' + _chalk2.default.cyan('$ pkg index.js') + '\n\n  ' + _chalk2.default.gray('–') + ' Takes package.json from cwd and follows \'bin\' entry\n\n    ' + _chalk2.default.cyan('$ pkg .') + '\n\n  ' + _chalk2.default.gray('–') + ' Makes executable for particular target machine\n\n    ' + _chalk2.default.cyan('$ pkg -t node6-linux-x64 index.js') + '\n\n  ' + _chalk2.default.gray('–') + ' Makes executables for your choice target machines\n\n    ' + _chalk2.default.cyan('$ pkg -t node4-linux,node6-linux,node6-win index.js') + '\n\n');
}