'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.exec = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var needViaCache = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(target) {
    var s, c;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            s = stringifyTarget(target);
            c = targetsCache[s];

            if (!c) {
              _context.next = 4;
              break;
            }

            return _context.abrupt('return', c);

          case 4:
            _context.next = 6;
            return (0, _pkgFetch.need)(target);

          case 6:
            c = _context.sent;

            targetsCache[s] = c;
            return _context.abrupt('return', c);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function needViaCache(_x) {
    return _ref.apply(this, arguments);
  };
}();

var exec = exports.exec = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(argv2) {
    var argv, debug, forceBuild, input, inputJson, inputBin, bin, inputFin, config, configJson, output, outputDir, autoOutput, name, ext, targets, different, target, file, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, _target, _file, _iteratorNormalCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, _target2, _iteratorNormalCompletion6, _didIteratorError6, _iteratorError6, _iterator6, _step6, _target3, f, tuple, records, stripes, _iteratorNormalCompletion7, _didIteratorError7, _iteratorError7, _iterator7, _step7, _target4, slash, _iteratorNormalCompletion8, _didIteratorError8, _iteratorError8, _iterator8, _step8, _target5;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            // eslint-disable-line complexity

            argv = (0, _minimist2.default)(argv2, {
              boolean: ['b', 'build', 'd', 'debug', 'h', 'help'],
              string: ['_', 'c', 'config', 'o', 'output', 'outdir', 'out-dir', 't', 'target', 'targets']
            });

            if (!(argv.h || argv.help)) {
              _context2.next = 4;
              break;
            }

            (0, _help2.default)();
            return _context2.abrupt('return');

          case 4:

            // debug

            debug = argv.d || argv.debug;

            _log.log.debugMode = debug;

            // forceBuild

            forceBuild = argv.b || argv.build;

            // _

            if (argv._.length) {
              _context2.next = 9;
              break;
            }

            throw (0, _log.wasReported)('At least one input file/directory is expected', ['Pass --help to see usage information']);

          case 9:
            if (!(argv._.length > 1)) {
              _context2.next = 11;
              break;
            }

            throw (0, _log.wasReported)('Not more than one input file/directory is expected');

          case 11:

            // input

            input = _path2.default.resolve(argv._[0]);
            _context2.next = 14;
            return (0, _fsPromise.exists)(input);

          case 14:
            if (_context2.sent) {
              _context2.next = 16;
              break;
            }

            throw (0, _log.wasReported)('Input file ' + input + ' does not exist');

          case 16:
            _context2.next = 18;
            return (0, _fsPromise.stat)(input);

          case 18:
            if (!_context2.sent.isDirectory()) {
              _context2.next = 24;
              break;
            }

            input = _path2.default.join(input, 'package.json');
            _context2.next = 22;
            return (0, _fsPromise.exists)(input);

          case 22:
            if (_context2.sent) {
              _context2.next = 24;
              break;
            }

            throw (0, _log.wasReported)('Input file ' + input + ' does not exist');

          case 24:

            // inputJson

            inputJson = null;

            if (!(0, _common.isPackageJson)(input)) {
              _context2.next = 31;
              break;
            }

            _context2.t0 = JSON;
            _context2.next = 29;
            return (0, _fsPromise.readFile)(input);

          case 29:
            _context2.t1 = _context2.sent;
            inputJson = _context2.t0.parse.call(_context2.t0, _context2.t1);

          case 31:

            // inputBin

            inputBin = null;

            if (!inputJson) {
              _context2.next = 41;
              break;
            }

            bin = inputJson.bin;

            if (!bin) {
              _context2.next = 41;
              break;
            }

            if ((typeof bin === 'undefined' ? 'undefined' : (0, _typeof3.default)(bin)) === 'object') {
              if (bin[inputJson.name]) {
                bin = bin[inputJson.name];
              } else {
                bin = bin[(0, _keys2.default)(bin)[0]]; // TODO multiple inputs to compile them all?
              }
            }
            inputBin = _path2.default.resolve(_path2.default.dirname(input), bin);
            _context2.next = 39;
            return (0, _fsPromise.exists)(inputBin);

          case 39:
            if (_context2.sent) {
              _context2.next = 41;
              break;
            }

            throw (0, _log.wasReported)('Package.json bin entry ' + inputBin + ' does not exist');

          case 41:

            // inputFin

            inputFin = inputBin || input;

            // config

            config = argv.c || argv.config;

            if (!(inputJson && config)) {
              _context2.next = 45;
              break;
            }

            throw (0, _log.wasReported)('Specify either \'package.json\' or config. Not both');

          case 45:

            // configJson

            configJson = null;

            if (!config) {
              _context2.next = 54;
              break;
            }

            config = _path2.default.resolve(config);
            _context2.next = 50;
            return (0, _fsPromise.exists)(config);

          case 50:
            if (_context2.sent) {
              _context2.next = 52;
              break;
            }

            throw (0, _log.wasReported)('Config file ' + config + ' does not exist');

          case 52:
            configJson = require(config); // may be either json or js
            if (!configJson.name && !configJson.files && !configJson.dependencies) {
              // package.json not detected
              configJson = { pkgConfig: configJson };
            }

          case 54:

            // output, outputDir

            output = argv.o || argv.output;
            outputDir = argv.outdir || argv['out-dir'];
            autoOutput = false;

            if (!(output && outputDir)) {
              _context2.next = 59;
              break;
            }

            throw (0, _log.wasReported)('Specify either \'output\' or \'out-dir\'. Not both');

          case 59:

            if (!output) {
              autoOutput = true;
              name = inputJson ? inputJson.name : _path2.default.basename(inputFin);
              ext = _path2.default.extname(name);

              output = name.slice(0, -ext.length || undefined);
              output = _path2.default.resolve(outputDir || '', output);
            }

            // targets

            targets = parseTarget(argv.t || argv.target || argv.targets);


            if (!targets.length) {
              if (!autoOutput) {
                targets = parseTarget('-');
                (0, _assert2.default)(targets.length === 1);
              } else {
                targets = parseTarget('linux,macos,win');
              }
              _log.log.info('Targets not specified. Assuming:', '' + targets.map(stringifyTarget).join(', '));
            }

            // differentParts

            different = differentParts(targets);

            // targets[].output

            if (!(targets.length === 1)) {
              _context2.next = 70;
              break;
            }

            target = targets[0];
            file = output;

            if (target.platform === 'win' && autoOutput) file += '.exe';
            target.output = file;
            _context2.next = 89;
            break;

          case 70:
            _iteratorNormalCompletion4 = true;
            _didIteratorError4 = false;
            _iteratorError4 = undefined;
            _context2.prev = 73;

            for (_iterator4 = (0, _getIterator3.default)(targets); !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              _target = _step4.value;
              _file = stringifyTargetForOutput(output, _target, different);

              if (_target.platform === 'win') _file += '.exe';
              _target.output = _file;
            }
            _context2.next = 81;
            break;

          case 77:
            _context2.prev = 77;
            _context2.t2 = _context2['catch'](73);
            _didIteratorError4 = true;
            _iteratorError4 = _context2.t2;

          case 81:
            _context2.prev = 81;
            _context2.prev = 82;

            if (!_iteratorNormalCompletion4 && _iterator4.return) {
              _iterator4.return();
            }

          case 84:
            _context2.prev = 84;

            if (!_didIteratorError4) {
              _context2.next = 87;
              break;
            }

            throw _iteratorError4;

          case 87:
            return _context2.finish(84);

          case 88:
            return _context2.finish(81);

          case 89:

            // check if input is going
            // to be overwritten by output

            _iteratorNormalCompletion5 = true;
            _didIteratorError5 = false;
            _iteratorError5 = undefined;
            _context2.prev = 92;
            _iterator5 = (0, _getIterator3.default)(targets);

          case 94:
            if (_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done) {
              _context2.next = 105;
              break;
            }

            _target2 = _step5.value;

            if (!(_target2.output === inputFin)) {
              _context2.next = 102;
              break;
            }

            if (!autoOutput) {
              _context2.next = 101;
              break;
            }

            _target2.output += '-' + _target2.platform;
            _context2.next = 102;
            break;

          case 101:
            throw (0, _log.wasReported)('Refusing to overwrite input ' + inputFin);

          case 102:
            _iteratorNormalCompletion5 = true;
            _context2.next = 94;
            break;

          case 105:
            _context2.next = 111;
            break;

          case 107:
            _context2.prev = 107;
            _context2.t3 = _context2['catch'](92);
            _didIteratorError5 = true;
            _iteratorError5 = _context2.t3;

          case 111:
            _context2.prev = 111;
            _context2.prev = 112;

            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }

          case 114:
            _context2.prev = 114;

            if (!_didIteratorError5) {
              _context2.next = 117;
              break;
            }

            throw _iteratorError5;

          case 117:
            return _context2.finish(114);

          case 118:
            return _context2.finish(111);

          case 119:

            // fetch targets

            _iteratorNormalCompletion6 = true;
            _didIteratorError6 = false;
            _iteratorError6 = undefined;
            _context2.prev = 122;
            _iterator6 = (0, _getIterator3.default)(targets);

          case 124:
            if (_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done) {
              _context2.next = 141;
              break;
            }

            _target3 = _step6.value;

            _target3.forceBuild = forceBuild;
            _context2.next = 129;
            return needViaCache(_target3);

          case 129:
            _target3.binaryPath = _context2.sent;
            f = _target3.fabricator = fabricatorForTarget(_target3);

            f.forceBuild = forceBuild;
            _context2.next = 134;
            return needViaCache(f);

          case 134:
            f.binaryPath = _context2.sent;

            if (!(f.platform !== 'win')) {
              _context2.next = 138;
              break;
            }

            _context2.next = 138;
            return (0, _chmod.plusx)(f.binaryPath);

          case 138:
            _iteratorNormalCompletion6 = true;
            _context2.next = 124;
            break;

          case 141:
            _context2.next = 147;
            break;

          case 143:
            _context2.prev = 143;
            _context2.t4 = _context2['catch'](122);
            _didIteratorError6 = true;
            _iteratorError6 = _context2.t4;

          case 147:
            _context2.prev = 147;
            _context2.prev = 148;

            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }

          case 150:
            _context2.prev = 150;

            if (!_didIteratorError6) {
              _context2.next = 153;
              break;
            }

            throw _iteratorError6;

          case 153:
            return _context2.finish(150);

          case 154:
            return _context2.finish(147);

          case 155:

            // tuple

            tuple = void 0;


            if (configJson) {
              tuple = {
                config: configJson,
                base: _path2.default.dirname(config)
              };
            } else {
              tuple = {
                config: inputJson || {},
                base: _path2.default.dirname(input) // not `inputBin` because only `input`
              }; // is the place for `inputJson`
            }

            // records

            _context2.next = 159;
            return (0, _walker2.default)({
              tuple: tuple, input: inputFin
            });

          case 159:
            records = _context2.sent;
            stripes = {};
            _iteratorNormalCompletion7 = true;
            _didIteratorError7 = false;
            _iteratorError7 = undefined;
            _context2.prev = 164;
            _iterator7 = (0, _getIterator3.default)(targets);

          case 166:
            if (_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done) {
              _context2.next = 177;
              break;
            }

            _target4 = _step7.value;
            slash = _target4.platform === 'win' ? '\\' : '/';

            _target4.slash = slash;

            if (stripes[slash]) {
              _context2.next = 174;
              break;
            }

            _context2.next = 173;
            return (0, _packer2.default)({ records: records, slash: slash });

          case 173:
            stripes[slash] = _context2.sent;

          case 174:
            _iteratorNormalCompletion7 = true;
            _context2.next = 166;
            break;

          case 177:
            _context2.next = 183;
            break;

          case 179:
            _context2.prev = 179;
            _context2.t5 = _context2['catch'](164);
            _didIteratorError7 = true;
            _iteratorError7 = _context2.t5;

          case 183:
            _context2.prev = 183;
            _context2.prev = 184;

            if (!_iteratorNormalCompletion7 && _iterator7.return) {
              _iterator7.return();
            }

          case 186:
            _context2.prev = 186;

            if (!_didIteratorError7) {
              _context2.next = 189;
              break;
            }

            throw _iteratorError7;

          case 189:
            return _context2.finish(186);

          case 190:
            return _context2.finish(183);

          case 191:

            _log.log.debug('Targets:', (0, _stringify2.default)(targets));

            _iteratorNormalCompletion8 = true;
            _didIteratorError8 = false;
            _iteratorError8 = undefined;
            _context2.prev = 195;
            _iterator8 = (0, _getIterator3.default)(targets);

          case 197:
            if (_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done) {
              _context2.next = 211;
              break;
            }

            _target5 = _step8.value;
            _context2.next = 201;
            return (0, _fsPromise.mkdirp)(_path2.default.dirname(_target5.output));

          case 201:
            _context2.next = 203;
            return (0, _fsPromise.remove)(_target5.output);

          case 203:
            _context2.next = 205;
            return (0, _producer2.default)({ stripe: stripes[_target5.slash], target: _target5 });

          case 205:
            if (!(_target5.platform !== 'win')) {
              _context2.next = 208;
              break;
            }

            _context2.next = 208;
            return (0, _chmod.plusx)(_target5.output);

          case 208:
            _iteratorNormalCompletion8 = true;
            _context2.next = 197;
            break;

          case 211:
            _context2.next = 217;
            break;

          case 213:
            _context2.prev = 213;
            _context2.t6 = _context2['catch'](195);
            _didIteratorError8 = true;
            _iteratorError8 = _context2.t6;

          case 217:
            _context2.prev = 217;
            _context2.prev = 218;

            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }

          case 220:
            _context2.prev = 220;

            if (!_didIteratorError8) {
              _context2.next = 223;
              break;
            }

            throw _iteratorError8;

          case 223:
            return _context2.finish(220);

          case 224:
            return _context2.finish(217);

          case 225:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[73, 77, 81, 89], [82,, 84, 88], [92, 107, 111, 119], [112,, 114, 118], [122, 143, 147, 155], [148,, 150, 154], [164, 179, 183, 191], [184,, 186, 190], [195, 213, 217, 225], [218,, 220, 224]]);
  }));

  return function exec(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _fsPromise = require('fs-promise');

var _log = require('./log.js');

var _pkgFetch = require('pkg-fetch');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _help = require('./help');

var _help2 = _interopRequireDefault(_help);

var _common = require('../runtime/common.js');

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _packer = require('./packer.js');

var _packer2 = _interopRequireDefault(_packer);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chmod = require('./chmod.js');

var _producer = require('./producer.js');

var _producer2 = _interopRequireDefault(_producer);

var _walker = require('./walker.js');

var _walker2 = _interopRequireDefault(_walker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hostArch = _pkgFetch.system.hostArch;
var hostPlatform = _pkgFetch.system.hostPlatform;
var knownArchs = _pkgFetch.system.knownArchs;
var knownPlatforms = _pkgFetch.system.knownPlatforms;
var toFancyArch = _pkgFetch.system.toFancyArch;
var toFancyPlatform = _pkgFetch.system.toFancyPlatform;

var hostNodeRange = 'node' + process.version[1];

function parseTarget(items) {
  // v6-macos-x64,v6-linux-x64
  if (!items) return [];
  var targets = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(items.split(',')), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var item = _step.value;

      var target = {
        nodeRange: hostNodeRange,
        platform: hostPlatform,
        arch: hostArch
      };
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)(item.split('-')), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var token = _step2.value;

          if (!token) continue;
          var p = toFancyPlatform(token);
          if (knownPlatforms.indexOf(p) >= 0) {
            target.platform = p;
            continue;
          }
          var a = toFancyArch(token);
          if (knownArchs.indexOf(a) >= 0) {
            target.arch = a;
            continue;
          }
          target.nodeRange = token;
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      targets.push(target);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return targets;
}

function stringifyTarget(target) {
  var nodeRange = target.nodeRange;
  var platform = target.platform;
  var arch = target.arch;

  return nodeRange + '-' + platform + '-' + arch;
}

function differentParts(targets) {
  var nodeRanges = {};
  var platforms = {};
  var archs = {};
  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = (0, _getIterator3.default)(targets), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var target = _step3.value;

      nodeRanges[target.nodeRange] = true;
      platforms[target.platform] = true;
      archs[target.arch] = true;
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  var result = {};
  if ((0, _keys2.default)(nodeRanges).length > 1) {
    result.nodeRange = true;
  }
  if ((0, _keys2.default)(platforms).length > 1) {
    result.platform = true;
  }
  if ((0, _keys2.default)(archs).length > 1) {
    result.arch = true;
  }
  return result;
}

function stringifyTargetForOutput(output, target, different) {
  var a = [output];
  if (different.nodeRange) a.push(target.nodeRange);
  if (different.platform) a.push(target.platform);
  if (different.arch) a.push(target.arch);
  return a.join('-');
}

function fabricatorForTarget(target) {
  var nodeRange = target.nodeRange;

  return { nodeRange: nodeRange, platform: hostPlatform, arch: hostArch };
}

var targetsCache = {};