'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = function (_ref) {
  var stripe = _ref.stripe;
  var target = _ref.target;

  return new _promise2.default(function (resolve, reject) {

    (0, _multistream2.default)([_fs2.default.createReadStream(target.binaryPath), function () {

      // TODO streams? from packer?
      // using miltistream factory?
      stripe = stripe.join('');
      var cmd = target.fabricator.binaryPath;
      var child = _child_process2.default.spawn(cmd, ['-e', script], { stdio: ['pipe', 'pipe', 'inherit'] });

      child.on('error', function (error) {
        reject(error);
      }).on('close', function (code) {
        if (code) {
          return reject(new Error(cmd + ' failed with code ' + code));
        }
      });

      child.stdin.write(prepend);
      child.stdin.write(stripe);
      child.stdin.write(append);
      child.stdin.end();
      return child.stdout;
    }]).pipe(_fs2.default.createWriteStream(target.output)).on('error', function (error) {
      reject(error);
    }).on('close', function () {
      resolve();
    });
  });
};

var _child_process = require('child_process');

var _child_process2 = _interopRequireDefault(_child_process);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _multistream = require('multistream');

var _multistream2 = _interopRequireDefault(_multistream);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var prepend = '(function(process, require, console) {\n';
var append = '\n})'; // dont remove \n

var script = '\n  var stdin = new Buffer(0);\n  process.stdin.on(\'data\', function (data) {\n    // TODO compare it with concat-stream approach\n    stdin = Buffer.concat([ stdin, data ]);\n  });\n  process.stdin.on(\'end\', function (data) {\n    var vm = require(\'vm\');\n    var s = new vm.Script(stdin, {\n      produceCachedData: true,\n      sourceless: true\n    });\n    // TODO check for reject\n    var prologue = new Buffer(16);\n    prologue.writeInt32LE(0x26e0c928, 0);\n    prologue.writeInt32LE(0x41f32b66, 4);\n    prologue.writeInt32LE(0x3ea13ccf, 8);\n    prologue.writeInt32LE(s.cachedData.length, 12);\n    process.stdout.write(prologue); // TODO padding?\n    process.stdout.write(s.cachedData);\n  });\n  process.stdin.resume();\n';